// +build !ignore_autogenerated_core_v1alpha3

/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by conversion-gen. DO NOT EDIT.

package v1alpha3

import (
	unsafe "unsafe"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	runtime "k8s.io/apimachinery/pkg/runtime"
	apiv1alpha3 "sigs.k8s.io/cluster-api/api/v1alpha3"
	apiv1alpha4 "sigs.k8s.io/cluster-api/api/v1alpha4"
	v1alpha4 "sigs.k8s.io/cluster-api/exp/addons/api/v1alpha4"
)

func init() {
	localSchemeBuilder.Register(RegisterConversions)
}

// RegisterConversions adds conversion functions to the given scheme.
// Public to allow building arbitrary schemes.
func RegisterConversions(s *runtime.Scheme) error {
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSet)(nil), (*v1alpha4.ClusterResourceSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSet_To_v1alpha4_ClusterResourceSet(a.(*ClusterResourceSet), b.(*v1alpha4.ClusterResourceSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSet)(nil), (*ClusterResourceSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSet_To_v1alpha3_ClusterResourceSet(a.(*v1alpha4.ClusterResourceSet), b.(*ClusterResourceSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetBinding)(nil), (*v1alpha4.ClusterResourceSetBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetBinding_To_v1alpha4_ClusterResourceSetBinding(a.(*ClusterResourceSetBinding), b.(*v1alpha4.ClusterResourceSetBinding), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetBinding)(nil), (*ClusterResourceSetBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetBinding_To_v1alpha3_ClusterResourceSetBinding(a.(*v1alpha4.ClusterResourceSetBinding), b.(*ClusterResourceSetBinding), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetBindingList)(nil), (*v1alpha4.ClusterResourceSetBindingList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetBindingList_To_v1alpha4_ClusterResourceSetBindingList(a.(*ClusterResourceSetBindingList), b.(*v1alpha4.ClusterResourceSetBindingList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetBindingList)(nil), (*ClusterResourceSetBindingList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetBindingList_To_v1alpha3_ClusterResourceSetBindingList(a.(*v1alpha4.ClusterResourceSetBindingList), b.(*ClusterResourceSetBindingList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetBindingSpec)(nil), (*v1alpha4.ClusterResourceSetBindingSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec(a.(*ClusterResourceSetBindingSpec), b.(*v1alpha4.ClusterResourceSetBindingSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetBindingSpec)(nil), (*ClusterResourceSetBindingSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec(a.(*v1alpha4.ClusterResourceSetBindingSpec), b.(*ClusterResourceSetBindingSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetList)(nil), (*v1alpha4.ClusterResourceSetList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetList_To_v1alpha4_ClusterResourceSetList(a.(*ClusterResourceSetList), b.(*v1alpha4.ClusterResourceSetList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetList)(nil), (*ClusterResourceSetList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetList_To_v1alpha3_ClusterResourceSetList(a.(*v1alpha4.ClusterResourceSetList), b.(*ClusterResourceSetList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetSpec)(nil), (*v1alpha4.ClusterResourceSetSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec(a.(*ClusterResourceSetSpec), b.(*v1alpha4.ClusterResourceSetSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetSpec)(nil), (*ClusterResourceSetSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec(a.(*v1alpha4.ClusterResourceSetSpec), b.(*ClusterResourceSetSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ClusterResourceSetStatus)(nil), (*v1alpha4.ClusterResourceSetStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus(a.(*ClusterResourceSetStatus), b.(*v1alpha4.ClusterResourceSetStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ClusterResourceSetStatus)(nil), (*ClusterResourceSetStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus(a.(*v1alpha4.ClusterResourceSetStatus), b.(*ClusterResourceSetStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ResourceBinding)(nil), (*v1alpha4.ResourceBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ResourceBinding_To_v1alpha4_ResourceBinding(a.(*ResourceBinding), b.(*v1alpha4.ResourceBinding), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ResourceBinding)(nil), (*ResourceBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ResourceBinding_To_v1alpha3_ResourceBinding(a.(*v1alpha4.ResourceBinding), b.(*ResourceBinding), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ResourceRef)(nil), (*v1alpha4.ResourceRef)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef(a.(*ResourceRef), b.(*v1alpha4.ResourceRef), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ResourceRef)(nil), (*ResourceRef)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef(a.(*v1alpha4.ResourceRef), b.(*ResourceRef), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*ResourceSetBinding)(nil), (*v1alpha4.ResourceSetBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha3_ResourceSetBinding_To_v1alpha4_ResourceSetBinding(a.(*ResourceSetBinding), b.(*v1alpha4.ResourceSetBinding), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1alpha4.ResourceSetBinding)(nil), (*ResourceSetBinding)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1alpha4_ResourceSetBinding_To_v1alpha3_ResourceSetBinding(a.(*v1alpha4.ResourceSetBinding), b.(*ResourceSetBinding), scope)
	}); err != nil {
		return err
	}
	return nil
}

func autoConvert_v1alpha3_ClusterResourceSet_To_v1alpha4_ClusterResourceSet(in *ClusterResourceSet, out *v1alpha4.ClusterResourceSet, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha3_ClusterResourceSet_To_v1alpha4_ClusterResourceSet is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSet_To_v1alpha4_ClusterResourceSet(in *ClusterResourceSet, out *v1alpha4.ClusterResourceSet, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSet_To_v1alpha4_ClusterResourceSet(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSet_To_v1alpha3_ClusterResourceSet(in *v1alpha4.ClusterResourceSet, out *ClusterResourceSet, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha4_ClusterResourceSet_To_v1alpha3_ClusterResourceSet is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSet_To_v1alpha3_ClusterResourceSet(in *v1alpha4.ClusterResourceSet, out *ClusterResourceSet, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSet_To_v1alpha3_ClusterResourceSet(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetBinding_To_v1alpha4_ClusterResourceSetBinding(in *ClusterResourceSetBinding, out *v1alpha4.ClusterResourceSetBinding, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha3_ClusterResourceSetBinding_To_v1alpha4_ClusterResourceSetBinding is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetBinding_To_v1alpha4_ClusterResourceSetBinding(in *ClusterResourceSetBinding, out *v1alpha4.ClusterResourceSetBinding, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetBinding_To_v1alpha4_ClusterResourceSetBinding(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetBinding_To_v1alpha3_ClusterResourceSetBinding(in *v1alpha4.ClusterResourceSetBinding, out *ClusterResourceSetBinding, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1alpha4_ClusterResourceSetBinding_To_v1alpha3_ClusterResourceSetBinding is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetBinding_To_v1alpha3_ClusterResourceSetBinding(in *v1alpha4.ClusterResourceSetBinding, out *ClusterResourceSetBinding, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetBinding_To_v1alpha3_ClusterResourceSetBinding(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetBindingList_To_v1alpha4_ClusterResourceSetBindingList(in *ClusterResourceSetBindingList, out *v1alpha4.ClusterResourceSetBindingList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]v1alpha4.ClusterResourceSetBinding)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha3_ClusterResourceSetBindingList_To_v1alpha4_ClusterResourceSetBindingList is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetBindingList_To_v1alpha4_ClusterResourceSetBindingList(in *ClusterResourceSetBindingList, out *v1alpha4.ClusterResourceSetBindingList, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetBindingList_To_v1alpha4_ClusterResourceSetBindingList(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetBindingList_To_v1alpha3_ClusterResourceSetBindingList(in *v1alpha4.ClusterResourceSetBindingList, out *ClusterResourceSetBindingList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]ClusterResourceSetBinding)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha4_ClusterResourceSetBindingList_To_v1alpha3_ClusterResourceSetBindingList is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetBindingList_To_v1alpha3_ClusterResourceSetBindingList(in *v1alpha4.ClusterResourceSetBindingList, out *ClusterResourceSetBindingList, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetBindingList_To_v1alpha3_ClusterResourceSetBindingList(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec(in *ClusterResourceSetBindingSpec, out *v1alpha4.ClusterResourceSetBindingSpec, s conversion.Scope) error {
	out.Bindings = *(*[]*v1alpha4.ResourceSetBinding)(unsafe.Pointer(&in.Bindings))
	return nil
}

// Convert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec(in *ClusterResourceSetBindingSpec, out *v1alpha4.ClusterResourceSetBindingSpec, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetBindingSpec_To_v1alpha4_ClusterResourceSetBindingSpec(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec(in *v1alpha4.ClusterResourceSetBindingSpec, out *ClusterResourceSetBindingSpec, s conversion.Scope) error {
	out.Bindings = *(*[]*ResourceSetBinding)(unsafe.Pointer(&in.Bindings))
	return nil
}

// Convert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec(in *v1alpha4.ClusterResourceSetBindingSpec, out *ClusterResourceSetBindingSpec, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetBindingSpec_To_v1alpha3_ClusterResourceSetBindingSpec(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetList_To_v1alpha4_ClusterResourceSetList(in *ClusterResourceSetList, out *v1alpha4.ClusterResourceSetList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]v1alpha4.ClusterResourceSet)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha3_ClusterResourceSetList_To_v1alpha4_ClusterResourceSetList is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetList_To_v1alpha4_ClusterResourceSetList(in *ClusterResourceSetList, out *v1alpha4.ClusterResourceSetList, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetList_To_v1alpha4_ClusterResourceSetList(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetList_To_v1alpha3_ClusterResourceSetList(in *v1alpha4.ClusterResourceSetList, out *ClusterResourceSetList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]ClusterResourceSet)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1alpha4_ClusterResourceSetList_To_v1alpha3_ClusterResourceSetList is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetList_To_v1alpha3_ClusterResourceSetList(in *v1alpha4.ClusterResourceSetList, out *ClusterResourceSetList, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetList_To_v1alpha3_ClusterResourceSetList(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec(in *ClusterResourceSetSpec, out *v1alpha4.ClusterResourceSetSpec, s conversion.Scope) error {
	out.ClusterSelector = in.ClusterSelector
	out.Resources = *(*[]v1alpha4.ResourceRef)(unsafe.Pointer(&in.Resources))
	out.Strategy = in.Strategy
	return nil
}

// Convert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec(in *ClusterResourceSetSpec, out *v1alpha4.ClusterResourceSetSpec, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetSpec_To_v1alpha4_ClusterResourceSetSpec(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec(in *v1alpha4.ClusterResourceSetSpec, out *ClusterResourceSetSpec, s conversion.Scope) error {
	out.ClusterSelector = in.ClusterSelector
	out.Resources = *(*[]ResourceRef)(unsafe.Pointer(&in.Resources))
	out.Strategy = in.Strategy
	return nil
}

// Convert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec(in *v1alpha4.ClusterResourceSetSpec, out *ClusterResourceSetSpec, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetSpec_To_v1alpha3_ClusterResourceSetSpec(in, out, s)
}

func autoConvert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus(in *ClusterResourceSetStatus, out *v1alpha4.ClusterResourceSetStatus, s conversion.Scope) error {
	out.ObservedGeneration = in.ObservedGeneration
	out.Conditions = *(*apiv1alpha4.Conditions)(unsafe.Pointer(&in.Conditions))
	return nil
}

// Convert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus is an autogenerated conversion function.
func Convert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus(in *ClusterResourceSetStatus, out *v1alpha4.ClusterResourceSetStatus, s conversion.Scope) error {
	return autoConvert_v1alpha3_ClusterResourceSetStatus_To_v1alpha4_ClusterResourceSetStatus(in, out, s)
}

func autoConvert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus(in *v1alpha4.ClusterResourceSetStatus, out *ClusterResourceSetStatus, s conversion.Scope) error {
	out.ObservedGeneration = in.ObservedGeneration
	out.Conditions = *(*apiv1alpha3.Conditions)(unsafe.Pointer(&in.Conditions))
	return nil
}

// Convert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus is an autogenerated conversion function.
func Convert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus(in *v1alpha4.ClusterResourceSetStatus, out *ClusterResourceSetStatus, s conversion.Scope) error {
	return autoConvert_v1alpha4_ClusterResourceSetStatus_To_v1alpha3_ClusterResourceSetStatus(in, out, s)
}

func autoConvert_v1alpha3_ResourceBinding_To_v1alpha4_ResourceBinding(in *ResourceBinding, out *v1alpha4.ResourceBinding, s conversion.Scope) error {
	if err := Convert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef(&in.ResourceRef, &out.ResourceRef, s); err != nil {
		return err
	}
	out.Hash = in.Hash
	out.LastAppliedTime = (*v1.Time)(unsafe.Pointer(in.LastAppliedTime))
	out.Applied = in.Applied
	return nil
}

// Convert_v1alpha3_ResourceBinding_To_v1alpha4_ResourceBinding is an autogenerated conversion function.
func Convert_v1alpha3_ResourceBinding_To_v1alpha4_ResourceBinding(in *ResourceBinding, out *v1alpha4.ResourceBinding, s conversion.Scope) error {
	return autoConvert_v1alpha3_ResourceBinding_To_v1alpha4_ResourceBinding(in, out, s)
}

func autoConvert_v1alpha4_ResourceBinding_To_v1alpha3_ResourceBinding(in *v1alpha4.ResourceBinding, out *ResourceBinding, s conversion.Scope) error {
	if err := Convert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef(&in.ResourceRef, &out.ResourceRef, s); err != nil {
		return err
	}
	out.Hash = in.Hash
	out.LastAppliedTime = (*v1.Time)(unsafe.Pointer(in.LastAppliedTime))
	out.Applied = in.Applied
	return nil
}

// Convert_v1alpha4_ResourceBinding_To_v1alpha3_ResourceBinding is an autogenerated conversion function.
func Convert_v1alpha4_ResourceBinding_To_v1alpha3_ResourceBinding(in *v1alpha4.ResourceBinding, out *ResourceBinding, s conversion.Scope) error {
	return autoConvert_v1alpha4_ResourceBinding_To_v1alpha3_ResourceBinding(in, out, s)
}

func autoConvert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef(in *ResourceRef, out *v1alpha4.ResourceRef, s conversion.Scope) error {
	out.Name = in.Name
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef is an autogenerated conversion function.
func Convert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef(in *ResourceRef, out *v1alpha4.ResourceRef, s conversion.Scope) error {
	return autoConvert_v1alpha3_ResourceRef_To_v1alpha4_ResourceRef(in, out, s)
}

func autoConvert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef(in *v1alpha4.ResourceRef, out *ResourceRef, s conversion.Scope) error {
	out.Name = in.Name
	out.Kind = in.Kind
	return nil
}

// Convert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef is an autogenerated conversion function.
func Convert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef(in *v1alpha4.ResourceRef, out *ResourceRef, s conversion.Scope) error {
	return autoConvert_v1alpha4_ResourceRef_To_v1alpha3_ResourceRef(in, out, s)
}

func autoConvert_v1alpha3_ResourceSetBinding_To_v1alpha4_ResourceSetBinding(in *ResourceSetBinding, out *v1alpha4.ResourceSetBinding, s conversion.Scope) error {
	out.ClusterResourceSetName = in.ClusterResourceSetName
	out.Resources = *(*[]v1alpha4.ResourceBinding)(unsafe.Pointer(&in.Resources))
	return nil
}

// Convert_v1alpha3_ResourceSetBinding_To_v1alpha4_ResourceSetBinding is an autogenerated conversion function.
func Convert_v1alpha3_ResourceSetBinding_To_v1alpha4_ResourceSetBinding(in *ResourceSetBinding, out *v1alpha4.ResourceSetBinding, s conversion.Scope) error {
	return autoConvert_v1alpha3_ResourceSetBinding_To_v1alpha4_ResourceSetBinding(in, out, s)
}

func autoConvert_v1alpha4_ResourceSetBinding_To_v1alpha3_ResourceSetBinding(in *v1alpha4.ResourceSetBinding, out *ResourceSetBinding, s conversion.Scope) error {
	out.ClusterResourceSetName = in.ClusterResourceSetName
	out.Resources = *(*[]ResourceBinding)(unsafe.Pointer(&in.Resources))
	return nil
}

// Convert_v1alpha4_ResourceSetBinding_To_v1alpha3_ResourceSetBinding is an autogenerated conversion function.
func Convert_v1alpha4_ResourceSetBinding_To_v1alpha3_ResourceSetBinding(in *v1alpha4.ResourceSetBinding, out *ResourceSetBinding, s conversion.Scope) error {
	return autoConvert_v1alpha4_ResourceSetBinding_To_v1alpha3_ResourceSetBinding(in, out, s)
}
